import { Plugin } from 'vite';
import { ts } from 'ts-morph';

declare type FilterType = string | RegExp | (string | RegExp)[] | null | undefined;
interface TransformWriteFile {
    filePath?: string;
    content?: string;
}
interface PluginOptions {
    include?: FilterType;
    exclude?: FilterType;
    root?: string;
    outputDir?: string;
    compilerOptions?: ts.CompilerOptions | null;
    tsConfigFilePath?: string;
    cleanVueFileName?: boolean;
    staticImport?: boolean;
    beforeWriteFile?: (filePath: string, content: string) => void | TransformWriteFile;
}
declare const _default: (options?: PluginOptions) => Plugin;

export default _default;
export { PluginOptions };
